//+------------------------------------------------------------------+
//|                                                ZigZag_AleksD.mq4 |
//|                                         Copyright  2008, AleksD |
//|                                                 http://ideal.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, AleksD"
#property link      "http://ideal.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Gold
#property indicator_color2 Blue
#property indicator_color3 Red

extern ENUM_TIMEFRAMES TimeFrame=PERIOD_CURRENT;
extern int       History=120;
extern int       Speed=6;

double ExtMapBuffer1[],ExtMapBuffer2[],ExtMapBuffer3[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(0,DRAW_SECTION);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(1,0.0);
   SetIndexStyle(1,DRAW_ARROW,EMPTY,2);
   SetIndexArrow(1,108);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(2,DRAW_ARROW,EMPTY,2);
   SetIndexArrow(2,108);
   SetIndexBuffer(2,ExtMapBuffer3);
   TimeFrame=MathMax(TimeFrame,_Period);
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int Swing,Swing_n,i,zu,zd;
   double LL,HH,BH,BL; 
   int limit = MathMin(Bars-1,History*TimeFrame/_Period);

   for (i=limit;i>=0;i--)
   { 
      ExtMapBuffer1[i]=0;
      ExtMapBuffer2[i]=0;
      ExtMapBuffer3[i]=0;
      int y = iBarShift(NULL,TimeFrame,Time[i]);
      int x = iBarShift(NULL,TimeFrame,Time[i+1]);
      if (y==x) continue;
      LL=iLow(NULL,TimeFrame,iLowest(NULL,TimeFrame,MODE_LOW,Speed,y+1));
      HH=iHigh(NULL,TimeFrame,iHighest(NULL,TimeFrame,MODE_HIGH,Speed,y+1));
      if (iLow(NULL,TimeFrame,y)<LL && iHigh(NULL,TimeFrame,y)>HH) { Swing=2; if (Swing_n==1) zu=i+1; if (Swing_n==-1) zd=i+1; }
      else {  if (iLow(NULL,TimeFrame,y)<LL) Swing=-1; if (iHigh(NULL,TimeFrame,y)>HH) Swing=1; }

      if (Swing!=Swing_n && Swing_n!=0)
      {
         if (Swing==2) { Swing=-Swing_n; BH = iHigh(NULL,TimeFrame,y); BL = iLow(NULL,TimeFrame,y);}
         if (Swing==1) {ExtMapBuffer1[zd]=BL;ExtMapBuffer2[i]=iLow(NULL,TimeFrame,y);}
         if (Swing==-1){ExtMapBuffer1[zu]=BH;ExtMapBuffer3[i]=iHigh(NULL,TimeFrame,y);}
         BH = iHigh(NULL,TimeFrame,y);
         BL = iLow(NULL,TimeFrame,y); 
      }
      if (Swing==1)
      {
         if (iHigh(NULL,TimeFrame,y)>=BH) { BH=iHigh(NULL,TimeFrame,y); zu=i; }
      } 
      if (Swing==-1)
      {
         if (iLow(NULL,TimeFrame,y)<=BL) { BL=iLow(NULL,TimeFrame,y); zd=i; }
      } 
      Swing_n=Swing;
   } 
   return(0);
}
//+------------------------------------------------------------------+